#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var buildClientSchema_1 = require("graphql/utilities/buildClientSchema");
var schemaPrinter_1 = require("graphql/utilities/schemaPrinter");
var fs_1 = __importDefault(require("fs"));
var minimist_1 = __importDefault(require("minimist"));
var version = require('../package.json').version;
var usage = "Usage: graphql-introspection-json-to-sdl schema.json > schema.graphql\n\nPrints the GraphQL schema SDL from a GraphQL schema JSON introspection.\n\nOptions:\n  --version, -v  Print version of graphql-introspection-json-to-sdl";
function main() {
    return __awaiter(this, void 0, void 0, function () {
        var argv, rawdata, rawjson, data, schema, data, schema;
        return __generator(this, function (_a) {
            argv = minimist_1.default(process.argv.slice(2));
            if (argv['version'] || argv['v']) {
                console.error(version);
                process.exit(0);
            }
            if (argv._.length < 1) {
                console.log(usage);
                process.exit(1);
            }
            rawdata = fs_1.default.readFileSync(argv._[0], { encoding: 'utf8' });
            rawjson = JSON.parse(rawdata);
            if (typeof rawjson === 'object') {
                if (typeof rawjson['__schema'] === 'object') {
                    data = rawjson;
                    schema = buildClientSchema_1.buildClientSchema(data);
                    console.log(schemaPrinter_1.printSchema(schema));
                }
                else if (typeof rawjson['data'] === 'object' && typeof rawjson['errors'] === 'undefined') {
                    data = rawjson['data'];
                    schema = buildClientSchema_1.buildClientSchema(data);
                    console.log(schemaPrinter_1.printSchema(schema));
                }
                else if (typeof rawjson['errors'] === 'object') {
                    throw new Error(JSON.stringify(rawjson['errors'], null, 2));
                }
                else {
                    throw new Error('No "data" key found in JSON object');
                }
            }
            else {
                throw new Error('Invalid JSON object');
            }
            return [2 /*return*/];
        });
    });
}
main().catch(function (e) {
    console.error(e);
    process.exit(1);
});
//# sourceMappingURL=index.js.map